---
title: XRWebGLLayerInit.ignoreDepthValues
slug: Web/API/XRWebGLLayerInit/ignoreDepthValues
tags:
  - API
  - AR
  - Compositing
  - Depth
  - Distance
  - Property
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRWebGLLayerInit
  - augmented
  - ignoreDepthValues
---
<p>{{securecontext_header}}{{APIRef("WebXR Device API")}}</p>

<p><span class="seoSummary">The {{domxref("XRWebGLLayerInit")}} dictionary's Boolean <code><strong>ignoreDepthValues</strong></code> property can be provided in the options passed into the {{domxref("XRWebGLLayer.XRWebGLLayer", "XRWebGLLayer()")}} constructor to indicate that the depth buffer, if it exists, should be ignored while composing the scene.</span></p>

<p>The depth buffer is typically used to assist in ordering vertices and, by extension, polygons while compositing, to ensure that the scene is correctly composited, with objects the correct distance away and with clipping and other distance-related computations performed as accurately as possible. Without the depth buffer, these computations must rely entirely on the coordinates of each pixel.</p>

<p>This property differs from {{domxref("XRWebGLLayerInit.depth", "depth")}} in that <code>depth</code> requests a WebGL layer that does not have a depth buffer at all, while <code>ignoreDepthValues</code> merely asks that the depth layer be ignored.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let layerInit = {
  ignoreDepthValues: <em>boolValue</em>
};
let glLayer = new XRWebGLLayer(xrSession, gl, layerInit);

let glLayer = new XRWebGLLayer(xrSession, gl, { ignoreDepthValues: <em>boolValue</em> });
</pre>

<h3 id="Value">Value</h3>

<p>A Boolean value which can be set to <code>true</code> to disable the use of the depth buffer by the WebGL rendering layer created by the {{domxref("XRWebGLLayer.XRWebGLLayer", "XRWebGLLayer()")}} constructor. The default value, <code>false</code>, means the depth buffer <em>will</em> be used, if available.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>If <code>ignoreDepthValues</code> is <code>true</code>, the WebXR compositor will ignore the contents of the depth buffer, if it exists, while compositing and rendering the scene. If <code>false</code>, the depth buffer's contents are used, if one is present.</p>

<p>Using a depth buffer while compositing allows the XR compositor to help ensure the compositing is done as accurately as possible. Each entry in the depth buffer corresponds to the depth of the fragment whose color is at the same location in the color buffer, and must have a value between 0.0 and 1.0, where 0.0 corresponds to the distance specified in the {{domxref("XRSession")}} object's {{domxref("XRSession.renderState", "renderState")}} record's {{domxref("XRRenderState.depthNear", "depthNear")}} and 1.0 represents the distance given by {{domxref("XRRenderState.depthFar", "depthFar")}}.</p>

<p>Ignoring depth values causes the compositor to rely solely upon the relative position of objects to establish depth, and may result in less effective and less comfortable 3D effects. The default is <code>false</code> (depth values are used by default).</p>

<h2 id="Example">Example</h2>

<p>In this example, a new {{domxref("XRWebGLLayer")}} is created for a WebXR session, <code>xrSession</code>. It's configured to ignore depth values or an alpha channel.</p>

<pre class="brush: js">xrSession.updateRenderState({
  baseLayer: new XRWebGLLayer(xrSession, gl, {
     alpha: false,
     ignoredepthValues: true
  });
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrwebgllayerinit-ignoredepthvalues','XRWebGLLayerInit.ignoreDepthValues')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRWebGLLayerInit.ignoreDepthValues")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebGL_API/Tutorial/Getting_started_with_WebGL">Getting started with WebGL</a></li>
</ul>
